// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"time"

	"entgo.io/ent/dialect"
	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/google/uuid"
	"gitlab.com/pajaziti.bersen/agorus-ent/ent/item"
	"gitlab.com/pajaziti.bersen/agorus-ent/ent/itemmeta"
	"gitlab.com/pajaziti.bersen/agorus-ent/ent/user"
)

// ItemCreate is the builder for creating a Item entity.
type ItemCreate struct {
	config
	mutation *ItemMutation
	hooks    []Hook
	conflict []sql.ConflictOption
}

// SetName sets the "name" field.
func (ic *ItemCreate) SetName(s string) *ItemCreate {
	ic.mutation.SetName(s)
	return ic
}

// SetAmount sets the "amount" field.
func (ic *ItemCreate) SetAmount(f float64) *ItemCreate {
	ic.mutation.SetAmount(f)
	return ic
}

// SetOriginalAmount sets the "original_amount" field.
func (ic *ItemCreate) SetOriginalAmount(f float64) *ItemCreate {
	ic.mutation.SetOriginalAmount(f)
	return ic
}

// SetUserID sets the "user_id" field.
func (ic *ItemCreate) SetUserID(u uuid.UUID) *ItemCreate {
	ic.mutation.SetUserID(u)
	return ic
}

// SetRefID sets the "ref_id" field.
func (ic *ItemCreate) SetRefID(s string) *ItemCreate {
	ic.mutation.SetRefID(s)
	return ic
}

// SetNillableRefID sets the "ref_id" field if the given value is not nil.
func (ic *ItemCreate) SetNillableRefID(s *string) *ItemCreate {
	if s != nil {
		ic.SetRefID(*s)
	}
	return ic
}

// SetBuyURL sets the "buy_url" field.
func (ic *ItemCreate) SetBuyURL(s string) *ItemCreate {
	ic.mutation.SetBuyURL(s)
	return ic
}

// SetNillableBuyURL sets the "buy_url" field if the given value is not nil.
func (ic *ItemCreate) SetNillableBuyURL(s *string) *ItemCreate {
	if s != nil {
		ic.SetBuyURL(*s)
	}
	return ic
}

// SetThumbnail sets the "thumbnail" field.
func (ic *ItemCreate) SetThumbnail(s string) *ItemCreate {
	ic.mutation.SetThumbnail(s)
	return ic
}

// SetNillableThumbnail sets the "thumbnail" field if the given value is not nil.
func (ic *ItemCreate) SetNillableThumbnail(s *string) *ItemCreate {
	if s != nil {
		ic.SetThumbnail(*s)
	}
	return ic
}

// SetSku sets the "sku" field.
func (ic *ItemCreate) SetSku(s string) *ItemCreate {
	ic.mutation.SetSku(s)
	return ic
}

// SetNillableSku sets the "sku" field if the given value is not nil.
func (ic *ItemCreate) SetNillableSku(s *string) *ItemCreate {
	if s != nil {
		ic.SetSku(*s)
	}
	return ic
}

// SetCurrency sets the "currency" field.
func (ic *ItemCreate) SetCurrency(s string) *ItemCreate {
	ic.mutation.SetCurrency(s)
	return ic
}

// SetNillableCurrency sets the "currency" field if the given value is not nil.
func (ic *ItemCreate) SetNillableCurrency(s *string) *ItemCreate {
	if s != nil {
		ic.SetCurrency(*s)
	}
	return ic
}

// SetNativeAmount sets the "native_amount" field.
func (ic *ItemCreate) SetNativeAmount(f float64) *ItemCreate {
	ic.mutation.SetNativeAmount(f)
	return ic
}

// SetNillableNativeAmount sets the "native_amount" field if the given value is not nil.
func (ic *ItemCreate) SetNillableNativeAmount(f *float64) *ItemCreate {
	if f != nil {
		ic.SetNativeAmount(*f)
	}
	return ic
}

// SetCondition sets the "condition" field.
func (ic *ItemCreate) SetCondition(s string) *ItemCreate {
	ic.mutation.SetCondition(s)
	return ic
}

// SetNillableCondition sets the "condition" field if the given value is not nil.
func (ic *ItemCreate) SetNillableCondition(s *string) *ItemCreate {
	if s != nil {
		ic.SetCondition(*s)
	}
	return ic
}

// SetStock sets the "stock" field.
func (ic *ItemCreate) SetStock(i int) *ItemCreate {
	ic.mutation.SetStock(i)
	return ic
}

// SetNillableStock sets the "stock" field if the given value is not nil.
func (ic *ItemCreate) SetNillableStock(i *int) *ItemCreate {
	if i != nil {
		ic.SetStock(*i)
	}
	return ic
}

// SetCreatedAt sets the "created_at" field.
func (ic *ItemCreate) SetCreatedAt(t time.Time) *ItemCreate {
	ic.mutation.SetCreatedAt(t)
	return ic
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (ic *ItemCreate) SetNillableCreatedAt(t *time.Time) *ItemCreate {
	if t != nil {
		ic.SetCreatedAt(*t)
	}
	return ic
}

// SetUpdatedAt sets the "updated_at" field.
func (ic *ItemCreate) SetUpdatedAt(t time.Time) *ItemCreate {
	ic.mutation.SetUpdatedAt(t)
	return ic
}

// SetNillableUpdatedAt sets the "updated_at" field if the given value is not nil.
func (ic *ItemCreate) SetNillableUpdatedAt(t *time.Time) *ItemCreate {
	if t != nil {
		ic.SetUpdatedAt(*t)
	}
	return ic
}

// SetID sets the "id" field.
func (ic *ItemCreate) SetID(u uuid.UUID) *ItemCreate {
	ic.mutation.SetID(u)
	return ic
}

// SetNillableID sets the "id" field if the given value is not nil.
func (ic *ItemCreate) SetNillableID(u *uuid.UUID) *ItemCreate {
	if u != nil {
		ic.SetID(*u)
	}
	return ic
}

// SetUser sets the "user" edge to the User entity.
func (ic *ItemCreate) SetUser(u *User) *ItemCreate {
	return ic.SetUserID(u.ID)
}

// AddMetumIDs adds the "meta" edge to the ItemMeta entity by IDs.
func (ic *ItemCreate) AddMetumIDs(ids ...uuid.UUID) *ItemCreate {
	ic.mutation.AddMetumIDs(ids...)
	return ic
}

// AddMeta adds the "meta" edges to the ItemMeta entity.
func (ic *ItemCreate) AddMeta(i ...*ItemMeta) *ItemCreate {
	ids := make([]uuid.UUID, len(i))
	for j := range i {
		ids[j] = i[j].ID
	}
	return ic.AddMetumIDs(ids...)
}

// Mutation returns the ItemMutation object of the builder.
func (ic *ItemCreate) Mutation() *ItemMutation {
	return ic.mutation
}

// Save creates the Item in the database.
func (ic *ItemCreate) Save(ctx context.Context) (*Item, error) {
	var (
		err  error
		node *Item
	)
	ic.defaults()
	if len(ic.hooks) == 0 {
		if err = ic.check(); err != nil {
			return nil, err
		}
		node, err = ic.sqlSave(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*ItemMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			if err = ic.check(); err != nil {
				return nil, err
			}
			ic.mutation = mutation
			if node, err = ic.sqlSave(ctx); err != nil {
				return nil, err
			}
			mutation.id = &node.ID
			mutation.done = true
			return node, err
		})
		for i := len(ic.hooks) - 1; i >= 0; i-- {
			if ic.hooks[i] == nil {
				return nil, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = ic.hooks[i](mut)
		}
		v, err := mut.Mutate(ctx, ic.mutation)
		if err != nil {
			return nil, err
		}
		nv, ok := v.(*Item)
		if !ok {
			return nil, fmt.Errorf("unexpected node type %T returned from ItemMutation", v)
		}
		node = nv
	}
	return node, err
}

// SaveX calls Save and panics if Save returns an error.
func (ic *ItemCreate) SaveX(ctx context.Context) *Item {
	v, err := ic.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (ic *ItemCreate) Exec(ctx context.Context) error {
	_, err := ic.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (ic *ItemCreate) ExecX(ctx context.Context) {
	if err := ic.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (ic *ItemCreate) defaults() {
	if _, ok := ic.mutation.RefID(); !ok {
		v := item.DefaultRefID()
		ic.mutation.SetRefID(v)
	}
	if _, ok := ic.mutation.Currency(); !ok {
		v := item.DefaultCurrency
		ic.mutation.SetCurrency(v)
	}
	if _, ok := ic.mutation.Condition(); !ok {
		v := item.DefaultCondition
		ic.mutation.SetCondition(v)
	}
	if _, ok := ic.mutation.Stock(); !ok {
		v := item.DefaultStock
		ic.mutation.SetStock(v)
	}
	if _, ok := ic.mutation.CreatedAt(); !ok {
		v := item.DefaultCreatedAt()
		ic.mutation.SetCreatedAt(v)
	}
	if _, ok := ic.mutation.UpdatedAt(); !ok {
		v := item.DefaultUpdatedAt()
		ic.mutation.SetUpdatedAt(v)
	}
	if _, ok := ic.mutation.ID(); !ok {
		v := item.DefaultID()
		ic.mutation.SetID(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (ic *ItemCreate) check() error {
	if _, ok := ic.mutation.Name(); !ok {
		return &ValidationError{Name: "name", err: errors.New(`ent: missing required field "Item.name"`)}
	}
	if _, ok := ic.mutation.Amount(); !ok {
		return &ValidationError{Name: "amount", err: errors.New(`ent: missing required field "Item.amount"`)}
	}
	if _, ok := ic.mutation.OriginalAmount(); !ok {
		return &ValidationError{Name: "original_amount", err: errors.New(`ent: missing required field "Item.original_amount"`)}
	}
	if _, ok := ic.mutation.UserID(); !ok {
		return &ValidationError{Name: "user_id", err: errors.New(`ent: missing required field "Item.user_id"`)}
	}
	if _, ok := ic.mutation.Currency(); !ok {
		return &ValidationError{Name: "currency", err: errors.New(`ent: missing required field "Item.currency"`)}
	}
	if _, ok := ic.mutation.Condition(); !ok {
		return &ValidationError{Name: "condition", err: errors.New(`ent: missing required field "Item.condition"`)}
	}
	if _, ok := ic.mutation.Stock(); !ok {
		return &ValidationError{Name: "stock", err: errors.New(`ent: missing required field "Item.stock"`)}
	}
	if _, ok := ic.mutation.CreatedAt(); !ok {
		return &ValidationError{Name: "created_at", err: errors.New(`ent: missing required field "Item.created_at"`)}
	}
	if _, ok := ic.mutation.UpdatedAt(); !ok {
		return &ValidationError{Name: "updated_at", err: errors.New(`ent: missing required field "Item.updated_at"`)}
	}
	if _, ok := ic.mutation.UserID(); !ok {
		return &ValidationError{Name: "user", err: errors.New(`ent: missing required edge "Item.user"`)}
	}
	return nil
}

func (ic *ItemCreate) sqlSave(ctx context.Context) (*Item, error) {
	_node, _spec := ic.createSpec()
	if err := sqlgraph.CreateNode(ctx, ic.driver, _spec); err != nil {
		if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	if _spec.ID.Value != nil {
		if id, ok := _spec.ID.Value.(*uuid.UUID); ok {
			_node.ID = *id
		} else if err := _node.ID.Scan(_spec.ID.Value); err != nil {
			return nil, err
		}
	}
	return _node, nil
}

func (ic *ItemCreate) createSpec() (*Item, *sqlgraph.CreateSpec) {
	var (
		_node = &Item{config: ic.config}
		_spec = &sqlgraph.CreateSpec{
			Table: item.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeUUID,
				Column: item.FieldID,
			},
		}
	)
	_spec.OnConflict = ic.conflict
	if id, ok := ic.mutation.ID(); ok {
		_node.ID = id
		_spec.ID.Value = &id
	}
	if value, ok := ic.mutation.Name(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: item.FieldName,
		})
		_node.Name = value
	}
	if value, ok := ic.mutation.Amount(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeFloat64,
			Value:  value,
			Column: item.FieldAmount,
		})
		_node.Amount = value
	}
	if value, ok := ic.mutation.OriginalAmount(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeFloat64,
			Value:  value,
			Column: item.FieldOriginalAmount,
		})
		_node.OriginalAmount = value
	}
	if value, ok := ic.mutation.RefID(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: item.FieldRefID,
		})
		_node.RefID = value
	}
	if value, ok := ic.mutation.BuyURL(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: item.FieldBuyURL,
		})
		_node.BuyURL = value
	}
	if value, ok := ic.mutation.Thumbnail(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: item.FieldThumbnail,
		})
		_node.Thumbnail = value
	}
	if value, ok := ic.mutation.Sku(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: item.FieldSku,
		})
		_node.Sku = value
	}
	if value, ok := ic.mutation.Currency(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: item.FieldCurrency,
		})
		_node.Currency = value
	}
	if value, ok := ic.mutation.NativeAmount(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeFloat64,
			Value:  value,
			Column: item.FieldNativeAmount,
		})
		_node.NativeAmount = value
	}
	if value, ok := ic.mutation.Condition(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: item.FieldCondition,
		})
		_node.Condition = value
	}
	if value, ok := ic.mutation.Stock(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeInt,
			Value:  value,
			Column: item.FieldStock,
		})
		_node.Stock = value
	}
	if value, ok := ic.mutation.CreatedAt(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeTime,
			Value:  value,
			Column: item.FieldCreatedAt,
		})
		_node.CreatedAt = value
	}
	if value, ok := ic.mutation.UpdatedAt(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeTime,
			Value:  value,
			Column: item.FieldUpdatedAt,
		})
		_node.UpdatedAt = value
	}
	if nodes := ic.mutation.UserIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: false,
			Table:   item.UserTable,
			Columns: []string{item.UserColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: user.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_node.UserID = nodes[0]
		_spec.Edges = append(_spec.Edges, edge)
	}
	if nodes := ic.mutation.MetaIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   item.MetaTable,
			Columns: []string{item.MetaColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: itemmeta.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges = append(_spec.Edges, edge)
	}
	return _node, _spec
}

// OnConflict allows configuring the `ON CONFLICT` / `ON DUPLICATE KEY` clause
// of the `INSERT` statement. For example:
//
//	client.Item.Create().
//		SetName(v).
//		OnConflict(
//			// Update the row with the new values
//			// the was proposed for insertion.
//			sql.ResolveWithNewValues(),
//		).
//		// Override some of the fields with custom
//		// update values.
//		Update(func(u *ent.ItemUpsert) {
//			SetName(v+v).
//		}).
//		Exec(ctx)
func (ic *ItemCreate) OnConflict(opts ...sql.ConflictOption) *ItemUpsertOne {
	ic.conflict = opts
	return &ItemUpsertOne{
		create: ic,
	}
}

// OnConflictColumns calls `OnConflict` and configures the columns
// as conflict target. Using this option is equivalent to using:
//
//	client.Item.Create().
//		OnConflict(sql.ConflictColumns(columns...)).
//		Exec(ctx)
func (ic *ItemCreate) OnConflictColumns(columns ...string) *ItemUpsertOne {
	ic.conflict = append(ic.conflict, sql.ConflictColumns(columns...))
	return &ItemUpsertOne{
		create: ic,
	}
}

type (
	// ItemUpsertOne is the builder for "upsert"-ing
	//  one Item node.
	ItemUpsertOne struct {
		create *ItemCreate
	}

	// ItemUpsert is the "OnConflict" setter.
	ItemUpsert struct {
		*sql.UpdateSet
	}
)

// SetName sets the "name" field.
func (u *ItemUpsert) SetName(v string) *ItemUpsert {
	u.Set(item.FieldName, v)
	return u
}

// UpdateName sets the "name" field to the value that was provided on create.
func (u *ItemUpsert) UpdateName() *ItemUpsert {
	u.SetExcluded(item.FieldName)
	return u
}

// SetAmount sets the "amount" field.
func (u *ItemUpsert) SetAmount(v float64) *ItemUpsert {
	u.Set(item.FieldAmount, v)
	return u
}

// UpdateAmount sets the "amount" field to the value that was provided on create.
func (u *ItemUpsert) UpdateAmount() *ItemUpsert {
	u.SetExcluded(item.FieldAmount)
	return u
}

// AddAmount adds v to the "amount" field.
func (u *ItemUpsert) AddAmount(v float64) *ItemUpsert {
	u.Add(item.FieldAmount, v)
	return u
}

// SetOriginalAmount sets the "original_amount" field.
func (u *ItemUpsert) SetOriginalAmount(v float64) *ItemUpsert {
	u.Set(item.FieldOriginalAmount, v)
	return u
}

// UpdateOriginalAmount sets the "original_amount" field to the value that was provided on create.
func (u *ItemUpsert) UpdateOriginalAmount() *ItemUpsert {
	u.SetExcluded(item.FieldOriginalAmount)
	return u
}

// AddOriginalAmount adds v to the "original_amount" field.
func (u *ItemUpsert) AddOriginalAmount(v float64) *ItemUpsert {
	u.Add(item.FieldOriginalAmount, v)
	return u
}

// SetUserID sets the "user_id" field.
func (u *ItemUpsert) SetUserID(v uuid.UUID) *ItemUpsert {
	u.Set(item.FieldUserID, v)
	return u
}

// UpdateUserID sets the "user_id" field to the value that was provided on create.
func (u *ItemUpsert) UpdateUserID() *ItemUpsert {
	u.SetExcluded(item.FieldUserID)
	return u
}

// SetRefID sets the "ref_id" field.
func (u *ItemUpsert) SetRefID(v string) *ItemUpsert {
	u.Set(item.FieldRefID, v)
	return u
}

// UpdateRefID sets the "ref_id" field to the value that was provided on create.
func (u *ItemUpsert) UpdateRefID() *ItemUpsert {
	u.SetExcluded(item.FieldRefID)
	return u
}

// ClearRefID clears the value of the "ref_id" field.
func (u *ItemUpsert) ClearRefID() *ItemUpsert {
	u.SetNull(item.FieldRefID)
	return u
}

// SetBuyURL sets the "buy_url" field.
func (u *ItemUpsert) SetBuyURL(v string) *ItemUpsert {
	u.Set(item.FieldBuyURL, v)
	return u
}

// UpdateBuyURL sets the "buy_url" field to the value that was provided on create.
func (u *ItemUpsert) UpdateBuyURL() *ItemUpsert {
	u.SetExcluded(item.FieldBuyURL)
	return u
}

// ClearBuyURL clears the value of the "buy_url" field.
func (u *ItemUpsert) ClearBuyURL() *ItemUpsert {
	u.SetNull(item.FieldBuyURL)
	return u
}

// SetThumbnail sets the "thumbnail" field.
func (u *ItemUpsert) SetThumbnail(v string) *ItemUpsert {
	u.Set(item.FieldThumbnail, v)
	return u
}

// UpdateThumbnail sets the "thumbnail" field to the value that was provided on create.
func (u *ItemUpsert) UpdateThumbnail() *ItemUpsert {
	u.SetExcluded(item.FieldThumbnail)
	return u
}

// ClearThumbnail clears the value of the "thumbnail" field.
func (u *ItemUpsert) ClearThumbnail() *ItemUpsert {
	u.SetNull(item.FieldThumbnail)
	return u
}

// SetSku sets the "sku" field.
func (u *ItemUpsert) SetSku(v string) *ItemUpsert {
	u.Set(item.FieldSku, v)
	return u
}

// UpdateSku sets the "sku" field to the value that was provided on create.
func (u *ItemUpsert) UpdateSku() *ItemUpsert {
	u.SetExcluded(item.FieldSku)
	return u
}

// ClearSku clears the value of the "sku" field.
func (u *ItemUpsert) ClearSku() *ItemUpsert {
	u.SetNull(item.FieldSku)
	return u
}

// SetCurrency sets the "currency" field.
func (u *ItemUpsert) SetCurrency(v string) *ItemUpsert {
	u.Set(item.FieldCurrency, v)
	return u
}

// UpdateCurrency sets the "currency" field to the value that was provided on create.
func (u *ItemUpsert) UpdateCurrency() *ItemUpsert {
	u.SetExcluded(item.FieldCurrency)
	return u
}

// SetNativeAmount sets the "native_amount" field.
func (u *ItemUpsert) SetNativeAmount(v float64) *ItemUpsert {
	u.Set(item.FieldNativeAmount, v)
	return u
}

// UpdateNativeAmount sets the "native_amount" field to the value that was provided on create.
func (u *ItemUpsert) UpdateNativeAmount() *ItemUpsert {
	u.SetExcluded(item.FieldNativeAmount)
	return u
}

// AddNativeAmount adds v to the "native_amount" field.
func (u *ItemUpsert) AddNativeAmount(v float64) *ItemUpsert {
	u.Add(item.FieldNativeAmount, v)
	return u
}

// ClearNativeAmount clears the value of the "native_amount" field.
func (u *ItemUpsert) ClearNativeAmount() *ItemUpsert {
	u.SetNull(item.FieldNativeAmount)
	return u
}

// SetCondition sets the "condition" field.
func (u *ItemUpsert) SetCondition(v string) *ItemUpsert {
	u.Set(item.FieldCondition, v)
	return u
}

// UpdateCondition sets the "condition" field to the value that was provided on create.
func (u *ItemUpsert) UpdateCondition() *ItemUpsert {
	u.SetExcluded(item.FieldCondition)
	return u
}

// SetStock sets the "stock" field.
func (u *ItemUpsert) SetStock(v int) *ItemUpsert {
	u.Set(item.FieldStock, v)
	return u
}

// UpdateStock sets the "stock" field to the value that was provided on create.
func (u *ItemUpsert) UpdateStock() *ItemUpsert {
	u.SetExcluded(item.FieldStock)
	return u
}

// AddStock adds v to the "stock" field.
func (u *ItemUpsert) AddStock(v int) *ItemUpsert {
	u.Add(item.FieldStock, v)
	return u
}

// SetCreatedAt sets the "created_at" field.
func (u *ItemUpsert) SetCreatedAt(v time.Time) *ItemUpsert {
	u.Set(item.FieldCreatedAt, v)
	return u
}

// UpdateCreatedAt sets the "created_at" field to the value that was provided on create.
func (u *ItemUpsert) UpdateCreatedAt() *ItemUpsert {
	u.SetExcluded(item.FieldCreatedAt)
	return u
}

// SetUpdatedAt sets the "updated_at" field.
func (u *ItemUpsert) SetUpdatedAt(v time.Time) *ItemUpsert {
	u.Set(item.FieldUpdatedAt, v)
	return u
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *ItemUpsert) UpdateUpdatedAt() *ItemUpsert {
	u.SetExcluded(item.FieldUpdatedAt)
	return u
}

// UpdateNewValues updates the mutable fields using the new values that were set on create except the ID field.
// Using this option is equivalent to using:
//
//	client.Item.Create().
//		OnConflict(
//			sql.ResolveWithNewValues(),
//			sql.ResolveWith(func(u *sql.UpdateSet) {
//				u.SetIgnore(item.FieldID)
//			}),
//		).
//		Exec(ctx)
func (u *ItemUpsertOne) UpdateNewValues() *ItemUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithNewValues())
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(s *sql.UpdateSet) {
		if _, exists := u.create.mutation.ID(); exists {
			s.SetIgnore(item.FieldID)
		}
	}))
	return u
}

// Ignore sets each column to itself in case of conflict.
// Using this option is equivalent to using:
//
//	client.Item.Create().
//	    OnConflict(sql.ResolveWithIgnore()).
//	    Exec(ctx)
func (u *ItemUpsertOne) Ignore() *ItemUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithIgnore())
	return u
}

// DoNothing configures the conflict_action to `DO NOTHING`.
// Supported only by SQLite and PostgreSQL.
func (u *ItemUpsertOne) DoNothing() *ItemUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.DoNothing())
	return u
}

// Update allows overriding fields `UPDATE` values. See the ItemCreate.OnConflict
// documentation for more info.
func (u *ItemUpsertOne) Update(set func(*ItemUpsert)) *ItemUpsertOne {
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(update *sql.UpdateSet) {
		set(&ItemUpsert{UpdateSet: update})
	}))
	return u
}

// SetName sets the "name" field.
func (u *ItemUpsertOne) SetName(v string) *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.SetName(v)
	})
}

// UpdateName sets the "name" field to the value that was provided on create.
func (u *ItemUpsertOne) UpdateName() *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateName()
	})
}

// SetAmount sets the "amount" field.
func (u *ItemUpsertOne) SetAmount(v float64) *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.SetAmount(v)
	})
}

// AddAmount adds v to the "amount" field.
func (u *ItemUpsertOne) AddAmount(v float64) *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.AddAmount(v)
	})
}

// UpdateAmount sets the "amount" field to the value that was provided on create.
func (u *ItemUpsertOne) UpdateAmount() *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateAmount()
	})
}

// SetOriginalAmount sets the "original_amount" field.
func (u *ItemUpsertOne) SetOriginalAmount(v float64) *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.SetOriginalAmount(v)
	})
}

// AddOriginalAmount adds v to the "original_amount" field.
func (u *ItemUpsertOne) AddOriginalAmount(v float64) *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.AddOriginalAmount(v)
	})
}

// UpdateOriginalAmount sets the "original_amount" field to the value that was provided on create.
func (u *ItemUpsertOne) UpdateOriginalAmount() *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateOriginalAmount()
	})
}

// SetUserID sets the "user_id" field.
func (u *ItemUpsertOne) SetUserID(v uuid.UUID) *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.SetUserID(v)
	})
}

// UpdateUserID sets the "user_id" field to the value that was provided on create.
func (u *ItemUpsertOne) UpdateUserID() *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateUserID()
	})
}

// SetRefID sets the "ref_id" field.
func (u *ItemUpsertOne) SetRefID(v string) *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.SetRefID(v)
	})
}

// UpdateRefID sets the "ref_id" field to the value that was provided on create.
func (u *ItemUpsertOne) UpdateRefID() *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateRefID()
	})
}

// ClearRefID clears the value of the "ref_id" field.
func (u *ItemUpsertOne) ClearRefID() *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.ClearRefID()
	})
}

// SetBuyURL sets the "buy_url" field.
func (u *ItemUpsertOne) SetBuyURL(v string) *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.SetBuyURL(v)
	})
}

// UpdateBuyURL sets the "buy_url" field to the value that was provided on create.
func (u *ItemUpsertOne) UpdateBuyURL() *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateBuyURL()
	})
}

// ClearBuyURL clears the value of the "buy_url" field.
func (u *ItemUpsertOne) ClearBuyURL() *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.ClearBuyURL()
	})
}

// SetThumbnail sets the "thumbnail" field.
func (u *ItemUpsertOne) SetThumbnail(v string) *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.SetThumbnail(v)
	})
}

// UpdateThumbnail sets the "thumbnail" field to the value that was provided on create.
func (u *ItemUpsertOne) UpdateThumbnail() *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateThumbnail()
	})
}

// ClearThumbnail clears the value of the "thumbnail" field.
func (u *ItemUpsertOne) ClearThumbnail() *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.ClearThumbnail()
	})
}

// SetSku sets the "sku" field.
func (u *ItemUpsertOne) SetSku(v string) *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.SetSku(v)
	})
}

// UpdateSku sets the "sku" field to the value that was provided on create.
func (u *ItemUpsertOne) UpdateSku() *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateSku()
	})
}

// ClearSku clears the value of the "sku" field.
func (u *ItemUpsertOne) ClearSku() *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.ClearSku()
	})
}

// SetCurrency sets the "currency" field.
func (u *ItemUpsertOne) SetCurrency(v string) *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.SetCurrency(v)
	})
}

// UpdateCurrency sets the "currency" field to the value that was provided on create.
func (u *ItemUpsertOne) UpdateCurrency() *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateCurrency()
	})
}

// SetNativeAmount sets the "native_amount" field.
func (u *ItemUpsertOne) SetNativeAmount(v float64) *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.SetNativeAmount(v)
	})
}

// AddNativeAmount adds v to the "native_amount" field.
func (u *ItemUpsertOne) AddNativeAmount(v float64) *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.AddNativeAmount(v)
	})
}

// UpdateNativeAmount sets the "native_amount" field to the value that was provided on create.
func (u *ItemUpsertOne) UpdateNativeAmount() *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateNativeAmount()
	})
}

// ClearNativeAmount clears the value of the "native_amount" field.
func (u *ItemUpsertOne) ClearNativeAmount() *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.ClearNativeAmount()
	})
}

// SetCondition sets the "condition" field.
func (u *ItemUpsertOne) SetCondition(v string) *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.SetCondition(v)
	})
}

// UpdateCondition sets the "condition" field to the value that was provided on create.
func (u *ItemUpsertOne) UpdateCondition() *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateCondition()
	})
}

// SetStock sets the "stock" field.
func (u *ItemUpsertOne) SetStock(v int) *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.SetStock(v)
	})
}

// AddStock adds v to the "stock" field.
func (u *ItemUpsertOne) AddStock(v int) *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.AddStock(v)
	})
}

// UpdateStock sets the "stock" field to the value that was provided on create.
func (u *ItemUpsertOne) UpdateStock() *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateStock()
	})
}

// SetCreatedAt sets the "created_at" field.
func (u *ItemUpsertOne) SetCreatedAt(v time.Time) *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.SetCreatedAt(v)
	})
}

// UpdateCreatedAt sets the "created_at" field to the value that was provided on create.
func (u *ItemUpsertOne) UpdateCreatedAt() *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateCreatedAt()
	})
}

// SetUpdatedAt sets the "updated_at" field.
func (u *ItemUpsertOne) SetUpdatedAt(v time.Time) *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.SetUpdatedAt(v)
	})
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *ItemUpsertOne) UpdateUpdatedAt() *ItemUpsertOne {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateUpdatedAt()
	})
}

// Exec executes the query.
func (u *ItemUpsertOne) Exec(ctx context.Context) error {
	if len(u.create.conflict) == 0 {
		return errors.New("ent: missing options for ItemCreate.OnConflict")
	}
	return u.create.Exec(ctx)
}

// ExecX is like Exec, but panics if an error occurs.
func (u *ItemUpsertOne) ExecX(ctx context.Context) {
	if err := u.create.Exec(ctx); err != nil {
		panic(err)
	}
}

// Exec executes the UPSERT query and returns the inserted/updated ID.
func (u *ItemUpsertOne) ID(ctx context.Context) (id uuid.UUID, err error) {
	if u.create.driver.Dialect() == dialect.MySQL {
		// In case of "ON CONFLICT", there is no way to get back non-numeric ID
		// fields from the database since MySQL does not support the RETURNING clause.
		return id, errors.New("ent: ItemUpsertOne.ID is not supported by MySQL driver. Use ItemUpsertOne.Exec instead")
	}
	node, err := u.create.Save(ctx)
	if err != nil {
		return id, err
	}
	return node.ID, nil
}

// IDX is like ID, but panics if an error occurs.
func (u *ItemUpsertOne) IDX(ctx context.Context) uuid.UUID {
	id, err := u.ID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// ItemCreateBulk is the builder for creating many Item entities in bulk.
type ItemCreateBulk struct {
	config
	builders []*ItemCreate
	conflict []sql.ConflictOption
}

// Save creates the Item entities in the database.
func (icb *ItemCreateBulk) Save(ctx context.Context) ([]*Item, error) {
	specs := make([]*sqlgraph.CreateSpec, len(icb.builders))
	nodes := make([]*Item, len(icb.builders))
	mutators := make([]Mutator, len(icb.builders))
	for i := range icb.builders {
		func(i int, root context.Context) {
			builder := icb.builders[i]
			builder.defaults()
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*ItemMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				nodes[i], specs[i] = builder.createSpec()
				var err error
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, icb.builders[i+1].mutation)
				} else {
					spec := &sqlgraph.BatchCreateSpec{Nodes: specs}
					spec.OnConflict = icb.conflict
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, icb.driver, spec); err != nil {
						if sqlgraph.IsConstraintError(err) {
							err = &ConstraintError{msg: err.Error(), wrap: err}
						}
					}
				}
				if err != nil {
					return nil, err
				}
				mutation.id = &nodes[i].ID
				mutation.done = true
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, icb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX is like Save, but panics if an error occurs.
func (icb *ItemCreateBulk) SaveX(ctx context.Context) []*Item {
	v, err := icb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (icb *ItemCreateBulk) Exec(ctx context.Context) error {
	_, err := icb.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (icb *ItemCreateBulk) ExecX(ctx context.Context) {
	if err := icb.Exec(ctx); err != nil {
		panic(err)
	}
}

// OnConflict allows configuring the `ON CONFLICT` / `ON DUPLICATE KEY` clause
// of the `INSERT` statement. For example:
//
//	client.Item.CreateBulk(builders...).
//		OnConflict(
//			// Update the row with the new values
//			// the was proposed for insertion.
//			sql.ResolveWithNewValues(),
//		).
//		// Override some of the fields with custom
//		// update values.
//		Update(func(u *ent.ItemUpsert) {
//			SetName(v+v).
//		}).
//		Exec(ctx)
func (icb *ItemCreateBulk) OnConflict(opts ...sql.ConflictOption) *ItemUpsertBulk {
	icb.conflict = opts
	return &ItemUpsertBulk{
		create: icb,
	}
}

// OnConflictColumns calls `OnConflict` and configures the columns
// as conflict target. Using this option is equivalent to using:
//
//	client.Item.Create().
//		OnConflict(sql.ConflictColumns(columns...)).
//		Exec(ctx)
func (icb *ItemCreateBulk) OnConflictColumns(columns ...string) *ItemUpsertBulk {
	icb.conflict = append(icb.conflict, sql.ConflictColumns(columns...))
	return &ItemUpsertBulk{
		create: icb,
	}
}

// ItemUpsertBulk is the builder for "upsert"-ing
// a bulk of Item nodes.
type ItemUpsertBulk struct {
	create *ItemCreateBulk
}

// UpdateNewValues updates the mutable fields using the new values that
// were set on create. Using this option is equivalent to using:
//
//	client.Item.Create().
//		OnConflict(
//			sql.ResolveWithNewValues(),
//			sql.ResolveWith(func(u *sql.UpdateSet) {
//				u.SetIgnore(item.FieldID)
//			}),
//		).
//		Exec(ctx)
func (u *ItemUpsertBulk) UpdateNewValues() *ItemUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithNewValues())
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(s *sql.UpdateSet) {
		for _, b := range u.create.builders {
			if _, exists := b.mutation.ID(); exists {
				s.SetIgnore(item.FieldID)
				return
			}
		}
	}))
	return u
}

// Ignore sets each column to itself in case of conflict.
// Using this option is equivalent to using:
//
//	client.Item.Create().
//		OnConflict(sql.ResolveWithIgnore()).
//		Exec(ctx)
func (u *ItemUpsertBulk) Ignore() *ItemUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWithIgnore())
	return u
}

// DoNothing configures the conflict_action to `DO NOTHING`.
// Supported only by SQLite and PostgreSQL.
func (u *ItemUpsertBulk) DoNothing() *ItemUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.DoNothing())
	return u
}

// Update allows overriding fields `UPDATE` values. See the ItemCreateBulk.OnConflict
// documentation for more info.
func (u *ItemUpsertBulk) Update(set func(*ItemUpsert)) *ItemUpsertBulk {
	u.create.conflict = append(u.create.conflict, sql.ResolveWith(func(update *sql.UpdateSet) {
		set(&ItemUpsert{UpdateSet: update})
	}))
	return u
}

// SetName sets the "name" field.
func (u *ItemUpsertBulk) SetName(v string) *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.SetName(v)
	})
}

// UpdateName sets the "name" field to the value that was provided on create.
func (u *ItemUpsertBulk) UpdateName() *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateName()
	})
}

// SetAmount sets the "amount" field.
func (u *ItemUpsertBulk) SetAmount(v float64) *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.SetAmount(v)
	})
}

// AddAmount adds v to the "amount" field.
func (u *ItemUpsertBulk) AddAmount(v float64) *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.AddAmount(v)
	})
}

// UpdateAmount sets the "amount" field to the value that was provided on create.
func (u *ItemUpsertBulk) UpdateAmount() *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateAmount()
	})
}

// SetOriginalAmount sets the "original_amount" field.
func (u *ItemUpsertBulk) SetOriginalAmount(v float64) *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.SetOriginalAmount(v)
	})
}

// AddOriginalAmount adds v to the "original_amount" field.
func (u *ItemUpsertBulk) AddOriginalAmount(v float64) *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.AddOriginalAmount(v)
	})
}

// UpdateOriginalAmount sets the "original_amount" field to the value that was provided on create.
func (u *ItemUpsertBulk) UpdateOriginalAmount() *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateOriginalAmount()
	})
}

// SetUserID sets the "user_id" field.
func (u *ItemUpsertBulk) SetUserID(v uuid.UUID) *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.SetUserID(v)
	})
}

// UpdateUserID sets the "user_id" field to the value that was provided on create.
func (u *ItemUpsertBulk) UpdateUserID() *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateUserID()
	})
}

// SetRefID sets the "ref_id" field.
func (u *ItemUpsertBulk) SetRefID(v string) *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.SetRefID(v)
	})
}

// UpdateRefID sets the "ref_id" field to the value that was provided on create.
func (u *ItemUpsertBulk) UpdateRefID() *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateRefID()
	})
}

// ClearRefID clears the value of the "ref_id" field.
func (u *ItemUpsertBulk) ClearRefID() *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.ClearRefID()
	})
}

// SetBuyURL sets the "buy_url" field.
func (u *ItemUpsertBulk) SetBuyURL(v string) *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.SetBuyURL(v)
	})
}

// UpdateBuyURL sets the "buy_url" field to the value that was provided on create.
func (u *ItemUpsertBulk) UpdateBuyURL() *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateBuyURL()
	})
}

// ClearBuyURL clears the value of the "buy_url" field.
func (u *ItemUpsertBulk) ClearBuyURL() *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.ClearBuyURL()
	})
}

// SetThumbnail sets the "thumbnail" field.
func (u *ItemUpsertBulk) SetThumbnail(v string) *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.SetThumbnail(v)
	})
}

// UpdateThumbnail sets the "thumbnail" field to the value that was provided on create.
func (u *ItemUpsertBulk) UpdateThumbnail() *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateThumbnail()
	})
}

// ClearThumbnail clears the value of the "thumbnail" field.
func (u *ItemUpsertBulk) ClearThumbnail() *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.ClearThumbnail()
	})
}

// SetSku sets the "sku" field.
func (u *ItemUpsertBulk) SetSku(v string) *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.SetSku(v)
	})
}

// UpdateSku sets the "sku" field to the value that was provided on create.
func (u *ItemUpsertBulk) UpdateSku() *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateSku()
	})
}

// ClearSku clears the value of the "sku" field.
func (u *ItemUpsertBulk) ClearSku() *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.ClearSku()
	})
}

// SetCurrency sets the "currency" field.
func (u *ItemUpsertBulk) SetCurrency(v string) *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.SetCurrency(v)
	})
}

// UpdateCurrency sets the "currency" field to the value that was provided on create.
func (u *ItemUpsertBulk) UpdateCurrency() *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateCurrency()
	})
}

// SetNativeAmount sets the "native_amount" field.
func (u *ItemUpsertBulk) SetNativeAmount(v float64) *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.SetNativeAmount(v)
	})
}

// AddNativeAmount adds v to the "native_amount" field.
func (u *ItemUpsertBulk) AddNativeAmount(v float64) *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.AddNativeAmount(v)
	})
}

// UpdateNativeAmount sets the "native_amount" field to the value that was provided on create.
func (u *ItemUpsertBulk) UpdateNativeAmount() *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateNativeAmount()
	})
}

// ClearNativeAmount clears the value of the "native_amount" field.
func (u *ItemUpsertBulk) ClearNativeAmount() *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.ClearNativeAmount()
	})
}

// SetCondition sets the "condition" field.
func (u *ItemUpsertBulk) SetCondition(v string) *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.SetCondition(v)
	})
}

// UpdateCondition sets the "condition" field to the value that was provided on create.
func (u *ItemUpsertBulk) UpdateCondition() *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateCondition()
	})
}

// SetStock sets the "stock" field.
func (u *ItemUpsertBulk) SetStock(v int) *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.SetStock(v)
	})
}

// AddStock adds v to the "stock" field.
func (u *ItemUpsertBulk) AddStock(v int) *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.AddStock(v)
	})
}

// UpdateStock sets the "stock" field to the value that was provided on create.
func (u *ItemUpsertBulk) UpdateStock() *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateStock()
	})
}

// SetCreatedAt sets the "created_at" field.
func (u *ItemUpsertBulk) SetCreatedAt(v time.Time) *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.SetCreatedAt(v)
	})
}

// UpdateCreatedAt sets the "created_at" field to the value that was provided on create.
func (u *ItemUpsertBulk) UpdateCreatedAt() *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateCreatedAt()
	})
}

// SetUpdatedAt sets the "updated_at" field.
func (u *ItemUpsertBulk) SetUpdatedAt(v time.Time) *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.SetUpdatedAt(v)
	})
}

// UpdateUpdatedAt sets the "updated_at" field to the value that was provided on create.
func (u *ItemUpsertBulk) UpdateUpdatedAt() *ItemUpsertBulk {
	return u.Update(func(s *ItemUpsert) {
		s.UpdateUpdatedAt()
	})
}

// Exec executes the query.
func (u *ItemUpsertBulk) Exec(ctx context.Context) error {
	for i, b := range u.create.builders {
		if len(b.conflict) != 0 {
			return fmt.Errorf("ent: OnConflict was set for builder %d. Set it on the ItemCreateBulk instead", i)
		}
	}
	if len(u.create.conflict) == 0 {
		return errors.New("ent: missing options for ItemCreateBulk.OnConflict")
	}
	return u.create.Exec(ctx)
}

// ExecX is like Exec, but panics if an error occurs.
func (u *ItemUpsertBulk) ExecX(ctx context.Context) {
	if err := u.create.Exec(ctx); err != nil {
		panic(err)
	}
}
